from PyQt6.Qsci import *


def getLexerList():
    return [
        {"lexer": QsciLexerAVS, "name": "AVS", "extension": [], "xmlapi": ""},
        {"lexer": QsciLexerBash, "name": "Bash", "extension": [".sh", ".bash", ".bsh", ".csh", ".bash_profile", ".bashrc", ".profile", ".recipe"], "xmlapi": "", "startswith": ["#!/bin/sh", "#!/bin/bash"]},
        {"lexer": QsciLexerBatch, "name": "Batch", "extension": [".bat", ".batch", ".cmd", ".nt"], "xmlapi": "batch"},
        {"lexer": QsciLexerCMake, "name": "CMake", "extension": [".cmake"], "xmlapi": "cmake"},
        {"lexer": QsciLexerCoffeeScript, "name": "CoffeeScript", "extension": [".coffe"".litcoffee"], "xmlapi": "coffee"}, {"lexer": QsciLexerCPP, "name": "C++", "extension": [".cpp", ".h", ".hh", ".hpp", ".hxx", ".cxx", ".cc", ".ino"], "xmlapi": "cpp"},
        {"lexer": QsciLexerCSharp, "name": "C#", "extension": ["cs"], "xmlapi": "cs"},
        {"lexer": QsciLexerIDL, "name": "IDL", "extension": [".idl"], "xmlapi": ""},
        {"lexer": QsciLexerJava, "name": "Java", "extension": [".java"], "xmlapi": "java"},
        {"lexer": QsciLexerJavaScript, "name": "JavaScript", "extension": [".js", ".jsm", ".jsx", ".ts", ".tsx"], "xmlapi": "javascript"},
        {"lexer": QsciLexerCSS, "name": "CSS", "extension": [".css", ".qss"], "xmlapi": "css"},
        {"lexer": QsciLexerD, "name": "D", "extension": [".d"], "xmlapi": ""},
        {"lexer": QsciLexerDiff, "name": "Diff", "extension": [".diff", ".patch"], "xmlapi": ""},
        {"lexer": QsciLexerFortran, "name": "Fortran", "extension": [".f90", ".f95", ".f03"], "xmlapi": ""},
        {"lexer": QsciLexerFortran77, "name": "Fortran77", "extension": [".f", ".for"], "xmlapi": ""},
        {"lexer": QsciLexerHTML, "name": "HTML", "extension": [".html", ".htm"], "xmlapi": "html", "startswith": ["<!DOCTYPE html>"]}, {"lexer": QsciLexerXML, "name": "XML", "extension": [".xml", ".xaml", ".xsl", ".xslt", ".xsd", ",.xul", ".kml", ".svg", ".mxml", ".xsml", ".wsdl", ".xlf", ".xliff", ".xbl", ".sxbl", ".sitemap", ".gml", ".gpx", ".plist"], "xmlapi": "xml", "startswith": ["<?xml"]},
        {"lexer": QsciLexerJSON, "name": "JSON", "extension": [".json"], "xmlapi": ""},
        {"lexer": QsciLexerLua, "name": "LUA", "extension": [".lua"], "xmlapi": "lua", "startswith": ["#!/usr/bin/lua", "#!/usr/bin/env lua"]},
        {"lexer": QsciLexerMakefile, "name": "Makefile", "extension": [".am"], "xmlapi": ""},
        {"lexer": QsciLexerMarkdown, "name": "Markdown", "extension": [".md"], "xmlapi": ""},
        {"lexer": QsciLexerMatlab, "name": "Matlab", "extension": [".m"], "xmlapi": ""},
        {"lexer": QsciLexerOctave, "name": "Octave", "extension": [], "xmlapi": ""},
        {"lexer": QsciLexerPascal, "name": "Pascal", "extension": [".pp"], "xmlapi": ""},
        {"lexer": QsciLexerPerl, "name": "Perl", "extension": [".pl"], "xmlapi": "perl", "startswith": ["#!/usr/bin/perl", "#!/usr/bin/env perl"]},
        {"lexer": QsciLexerPO, "name": "PO", "extension": [], "xmlapi": ""},
        {"lexer": QsciLexerPOV, "name": "POV", "extension": [], "xmlapi": ""},
        {"lexer": QsciLexerPostScript, "name": "PostScript", "extension": [], "xmlapi": ""},
        {"lexer": QsciLexerProperties, "name": "Properties", "extension": [".properties"], "xmlapi": ""},
        {"lexer": QsciLexerPython, "name": "Python", "extension": [".py", ".pyw"], "xmlapi": "python", "startswith": ["#!/usr/bin/python", "#!/usr/bin/env python"]},
        {"lexer": QsciLexerRuby, "name": "Ruby", "extension": [".rb", ".rbw"], "xmlapi": ""},
        {"lexer": QsciLexerSpice, "name": "Spice", "extension": [".scp", ".out"], "xmlapi": ""},
        {"lexer": QsciLexerSQL, "name": "SQL", "extension": [], "xmlapi": ""},
        {"lexer": QsciLexerTCL, "name": "TCL", "extension": [".tcl"], "xmlapi": ""},
        {"lexer": QsciLexerTeX, "name": "TeX", "extension": [".tex"], "xmlapi": "tex"},
        {"lexer": QsciLexerVerilog, "name": "Verilog", "extension": [".v", ".sv", ".vh", ".svh"], "xmlapi": ""}, {"lexer": QsciLexerVHDL, "name": "VHDL", "extension": [], "xmlapi": "vhdl"},
        {"lexer": QsciLexerYAML, "name": "YAML", "extension": [".yml", ".yaml"], "xmlapi": ""}
    ]
